CCMAKE(1)

NAME
ccmake - CMake Curses Dialog Command-Line Reference

SYNOPSIS

ccmake [<options>] (<path-to-source> | <path-to-existing-build>)

DESCRIPTION

The "ccmake" executable is the CMake curses interface. Project configuration settings may be specified interactively through this GUI. Brief instructions are provided at the bottom of the terminal when the program is running.

CMake is a cross-platform build system generator. Projects specify their build process with platform-independent CMake listfiles included in each directory of a source tree with the name CMakeLists.txt. Users build a project by using CMake to generate a build system for a native tool on their platform.

OPTIONS

-C <initial-cache>
    Pre-load a script to populate the cache.

    When cmake is first run in an empty build tree, it creates a CMakeCache.txt file and populates it with customizable settings for the project. This option may be used to specify a file from which to load cache entries before the first pass through the project's cmake listfiles. The loaded entries take priority over the project's default values. The given file should be a CMake script containing SET commands that use the CACHE option, not a cache-format file.

-D <var>:<type>=<value>, -D <var>=<value>
    Create a cmake cache entry.

    When cmake is first run in an empty build tree, it creates a CMakeCache.txt file and populates it with customizable settings for the project. This option may be used to specify a setting that takes priority over the project's default value. The option may be repeated for as many cache entries as desired.

    If the :<type> portion is given it must be one of the types specified by the set() command documentation for its CACHE signature. If the :<type> portion is omitted the entry will be created with no type if it does not exist with a type already. If a command in the project sets the type to PATH or FILEPATH then the <value> will be converted to an absolute path.

    This option may also be given as a single argument: -D<var>:<type>=<value> or -D<var>=<value>.

-U <globbing_expr>
    Remove matching entries from CMake cache.

    This option may be used to remove one or more variables from the CMakeCache.txt file, globbing expressions using * and ? are supported. The option may be repeated for as many cache entries as desired.

    Use with care, you can make your CMakeCache.txt non-working.

-G <generator-name>
    Specify a build system generator.

    CMake may support multiple native build systems on certain platforms. A generator is responsible for generating a particular build system. Possible generator names are specified in the cmake-generators(7) manual.

-T <toolset-name>
    Specify toolset name if supported by generator.

    Some CMake generators support a toolset name to be given to the native build system to choose a compiler. This is supported only on specific generators:

    Visual Studio >= 10
    Xcode >= 3.0

    See native build system documentation for allowed toolset names.

-A <platform-name>
    Specify platform name if supported by generator.

    Some CMake generators support a platform name to be given to the native build system to choose a compiler or SDK. See the CMAKE_GENERATOR_PLATFORM variable. This is supported only on specific generators:

•   For Visual Studio Generators with VS 2005 and above this specifies the target architecture.

    See native build system documentation for allowed platform names.

-Wno-dev
    Suppress developer warnings.

    Suppress warnings that are meant for the author of the CMakeLists.txt files. By default this will also turn off deprecation warnings.

-Wdev
    Enable developer warnings.

    Enable warnings that are meant for the author of the CMakeLists.txt files. By default this will also turn on deprecation warnings.

-Werror=dev
    Make developer warnings errors.

    Make warnings that are meant for the author of the CMakeLists.txt files errors. By default this will also turn on deprecated warnings as errors.

-Wno-error=dev
    Make developer warnings not errors.

    Make warnings that are meant for the author of the CMakeLists.txt files not errors. By default this will also turn off deprecated warnings as errors.

-Wdeprecated
    Enable deprecated functionality warnings.

    Enable warnings for usage of deprecated functionality, that are meant for the author of the CMakeLists.txt files.

-Wno-deprecated
    Suppress deprecated functionality warnings.

    Suppress warnings for usage of deprecated functionality, that are meant for the author of the CMakeLists.txt files.

-Werror=deprecated
    Make deprecated macro and function warnings errors.

    Make warnings for usage of deprecated macros and functions, that are meant for the author of the CMakeLists.txt files, errors.

-Wno-error=deprecated
    Make deprecated macro and function warnings not errors.

    Make warnings for usage of deprecated macros and functions, that are meant for the author of the CMakeLists.txt files, not errors.

--help,-help,-usage,-h,-H,/?
    Print usage information and exit.

    Usage describes the basic command line interface and its options.

--version,-version,/V [<f>]
    Show program name/version banner and exit.

    If a file is specified, the version is written into it. The help is printed to a named <f>ile if given.

--help-full [<f>]
    Print all help manuals and exit.

    All manuals are printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-manual <man> [<f>]
    Print one help manual and exit.

    The specified manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-manual-list [<f>]
    List help manuals available and exit.

    The list contains all manuals for which help may be obtained by using the --help-manual option followed by a manual name. The help is printed to a named <f>ile if given.

--help-command <cmd> [<f>]
    Print help for one command and exit.

    The cmake-commands(7) manual entry for <cmd> is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-command-list [<f>]
    List commands with help available and exit.

    The list contains all commands for which help may be obtained by using the --help-command option followed by a command name. The help is printed to a named <f>ile if given.

--help-commands [<f>]
    Print cmake-commands manual and exit.

    The cmake-commands(7) manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-module <mod> [<f>]
    Print help for one module and exit.

    The cmake-modules(7) manual entry for <mod> is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-module-list [<f>]
    List modules with help available and exit.

    The list contains all modules for which help may be obtained by using the --help-module option followed by a module name. The help is printed to a named <f>ile if given.

--help-modules [<f>]
    Print cmake-modules manual and exit.

    The cmake-modules(7) manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-policy <cmp> [<f>]
    Print help for one policy and exit.

    The cmake-policies(7) manual entry for <cmp> is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-policy-list [<f>]
    List policies with help available and exit.

    The list contains all policies for which help may be obtained by using the --help-policy option followed by a policy name. The help is printed to a named <f>ile if given.

--help-policies [<f>]
    Print cmake-policies manual and exit.

    The cmake-policies(7) manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-property <prop> [<f>]
    Print help for one property and exit.

    The cmake-properties(7) manual entries for <prop> are printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-property-list [<f>]
    List properties with help available and exit.

    The list contains all properties for which help may be obtained by using the --help-property option followed by a property name. The help is printed to a named <f>ile if given.

--help-properties [<f>]
    Print cmake-properties manual and exit.

    The cmake-properties(7) manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-variable <var> [<f>]
    Print help for one variable and exit.

    The cmake-variables(7) manual entry for <var> is printed in a human-readable text format. The help is printed to a named <f>ile if given.

--help-variable-list [<f>]
    List variables with help available and exit.

    The list contains all variables for which help may be obtained by using the --help-variable option followed by a variable name. The help is printed to a named <f>ile if given.

--help-variables [<f>]
    Print cmake-variables manual and exit.

    The cmake-variables(7) manual is printed in a human-readable text format. The help is printed to a named <f>ile if given.

SEE ALSO

The following resources are available to get help using CMake:

Home Page
    https://cmake.org

    The primary starting point for learning about CMake.

Frequently Asked Questions
    https://cmake.org/Wiki/CMake_FAQ

    A Wiki is provided containing answers to frequently asked questions.

Online Documentation
    https://cmake.org/documentation

    Links to available documentation may be found on this web page.

Mailing List
    https://cmake.org/mailing-lists

    For help and discussion about using cmake, a mailing list is provided at cmake@cmake.org. The list is member-post-only but one may sign up on the CMake web page. Please first read the full documentation at https://cmake.org before posting questions to the list.

COPYRIGHT
2000-2016 Kitware, Inc. and Contributors